CF1210F1.Marek and Matching (easy version)

NOI/NOI+/CTSC

通过率:0%

AC君温馨提醒

该题目为【codeforces】题库的题目,您提交的代码将被提交至codeforces进行远程评测,并由ACGO抓取测评结果后进行展示。由于远程测评的测评机由其他平台提供,我们无法保证该服务的稳定性,若提交后无反应,请等待一段时间后再进行重试。

题目描述

这是该问题的简化版本。在本版本中,n≤6n \le 6。

Marek 正在努力为他的新算法题目设计强有力的测试数据。你想知道题目内容吗?不,我们不会告诉你。不过,我们可以告诉你他是如何生成测试数据的。

Marek 选择一个整数 nn,以及 n2n^2 个整数 pijp_{ij}(1≤i≤n1 \le i \le n,1≤j≤n1 \le j \le n)。然后他生成一个有 2n2n 个点的随机二分图。左侧有 nn 个点:ℓ1,ℓ2,…,ℓn\ell_1, \ell_2, \dots, \ell_n,右侧有 nn 个点:r1,r2,…,rnr_1, r_2, \dots, r_n。对于每一对 ii 和 jj,他以 pijp_{ij} 的百分比概率,在 ℓi\ell_i 和 rjr_j 之间连一条边。

事实证明,只有当生成的图中存在完美匹配时,测试数据才是强有力的。问生成的二分图中存在完美匹配的概率是多少?

可以证明,这个概率可以表示为 PQ\frac{P}{Q},其中 PP 和 QQ 是互质的整数,且 Q≢0(mod109+7)Q \not\equiv 0 \pmod{10^9+7}。令 Q−1Q^{-1} 为满足 Q⋅Q−1≡1(mod109+7)Q \cdot Q^{-1} \equiv 1 \pmod{10^9+7} 的整数。请输出 P⋅Q−1 mod 109+7P \cdot Q^{-1} \bmod{10^9+7} 的值。

输入格式

输入的第一行包含一个整数 nn(1≤n≤61 \le n \le 6)。接下来的 nn 行描述每条边出现的概率。第 ii 行包含 nn 个整数 pi1,pi2,…,pinp_{i1}, p_{i2}, \dots, p_{in}(0≤pij≤1000 \le p_{ij} \le 100);pijp_{ij} 表示在 ℓi\ell_i 和 rjr_j 之间连边的概率(百分比)。

输出格式

输出一个整数——生成的二分图中存在完美匹配的概率,记作 P⋅Q−1 mod 109+7P \cdot Q^{-1} \bmod{10^9+7},其中 PP、QQ 如上所述。

输入输出样例

  • 输入#1

    2
    50 50
    50 50

    输出#1

    937500007
  • 输入#2

    3
    3 1 4
    1 5 9
    2 6 5

    输出#2

    351284554

说明/提示

在第一个样例测试中,所有 1616 种图出现的概率相等。其中有 77 种图存在完美匹配:

因此,概率为 716\frac{7}{16}。由于 16⋅562 500 004=1(mod109+7)16 \cdot 562\,500\,004 = 1 \pmod{10^9+7},所以本测试用例的答案为 7⋅562 500 004 mod 109+7=937 500 0077 \cdot 562\,500\,004 \bmod{10^9+7} = 937\,500\,007。

由 ChatGPT 4.1 翻译

输入解题思路,AI测评打分。不知道怎么写?

首页